;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%;
;    V. 0.41 (x) 2005                              ;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%;
; :		[0..eax-1]                                             ;
;------------------------------------------------------------------------------;
;      - "Multiply-With-Carry(MWC)"    ;
;     DIEHARD   2^125                         ;
;------------------------------------------------------------------------------;
; :        call	r_init                                         ;
;			mov	eax,                           ;
;			call	brandom32                                      ;
;------------------------------------------------------------------------------;
; :		   [0.. ]               ;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%;

;----[    ]-------------------;

r_init:
		push	ebp eax edx		;    ebp,eax,edx

		call	__delta1_		;
__delta1_:	pop	ebp			;   
		sub	ebp,offset __delta1_	;

		db	0fh,031h		;   
		mov	[ebp+x],eax		;

		pop	edx eax ebp		;  edx,eax,ebp

		ret				;   

;----[     ]----------------------;

brandom32:					;  
						;   
						;   0..eax-1

		push	edx ecx	ebp		;    edx,ecx,ebp

		call	__delta2_		;
__delta2_:	pop	ebp			;   
		sub	ebp,offset __delta2_	;

		imul	eax,eax,100		;  eax  100
		push	eax			;   eax  

		call	random32		;  
						;   
		xor	edx,edx			;  edx
		pop	ecx			;  
						;    ecx
		div	ecx			;  eax  ecx
		xchg	eax,edx			;    eax
		xor	edx,edx			;  edx
		push	100			;   ecx - 100
		pop	ecx			;
		div	ecx			;  eax  ecx
		pop	ebp ecx edx		;  ebp,ecx,edx,
		ret				;   

;----[   ]---------------------------------;

random32:
		push	edx ecx			;
		push	ebp			;    

		call	__delta3_		;
__delta3_:	pop	ebp			;   
		sub	ebp,offset __delta3_	;

                mov     eax,123456789		;    
		x = dword ptr $-4		; "Multipy-With-Carry(MWC)"
                mov     edx,916905900		;   
		t = dword ptr $-4		;     :
		mul	edx			; unsigned long x=123456789,
		xor	ecx,ecx			; y=362436069,
		xchg	ecx,edx			; z=77465321,
		add	eax,13579		; c=13579;
		c = dword ptr $-4		; unsigned long long t;
		adc	edx,ecx			; t=916905990LL*x+c;
		mov	ecx,362436069		; x=y;
		y = dword ptr $-4		; y=z;
		mov	[ebp+x],ecx		; c=(t>>32);
		mov	ecx,77465321		; return z=(t&0xffffffff);
		z = dword ptr $-4		;
		mov	[ebp+y],ecx		;
		mov	[ebp+c],edx		;
		mov	[ebp+z],eax		;

		pop	ebp			;
		pop	ecx edx 		;    

		retn				;   
